Container (Apache Tomcat 10.1.20 API Documentation)
Description: declaration: package: org.apache.catalina, interface: Container

Package org.apache.catalina

# Interface Container

All Superinterfaces:
  `Lifecycle`

All Known Subinterfaces:
  `Context`, `Engine`, `Host`, `Wrapper`

All Known Implementing Classes:
  `ContainerBase`, `FailedContext`, `ReplicatedContext`, `StandardContext`, `StandardEngine`, `StandardHost`, `StandardWrapper`, `Tomcat.ExistingStandardWrapper`

public interface Container extends Lifecycle
A Container is an object that can execute requests received from a client, and return responses based on those requests. A Container may optionally support a pipeline of Valves that process the request in an order configured at runtime, by implementing the Pipeline interface as well.

Containers will exist at several conceptual levels within Catalina. The following examples represent common cases:

- Engine - Representation of the entire Catalina servlet engine, most likely containing one or more subcontainers that are either Host or Context implementations, or other custom groups.
- Host - Representation of a virtual host containing a number of Contexts.
- Context - Representation of a single ServletContext, which will typically contain one or more Wrappers for the supported servlets.
- Wrapper - Representation of an individual servlet definition.

A given deployment of Catalina need not include Containers at all of the levels described above. For example, an administration application embedded within a network device (such as a router) might only contain a single Context and a few Wrappers, or even a single Wrapper if the application is relatively small. Therefore, Container implementations need to be designed so that they will operate correctly in the absence of parent Containers in a given deployment.

A Container may also be associated with a number of support components that provide functionality which might be shared (by attaching it to a parent Container) or individually customized. The following support components are currently recognized:

- Loader - Class loader to use for integrating new Java classes for this Container into the JVM in which Catalina is running.
- Logger - Implementation of the `log()` method signatures of the `ServletContext` interface.
- Manager - Manager for the pool of Sessions associated with this Container.
- Realm - Read-only interface to a security domain, for authenticating user identities and their corresponding roles.
- Resources - JNDI directory context enabling access to static resources, enabling custom linkages to existing server components when Catalina is embedded in a larger server.

Author:
  Craig R. McClanahan, Remy Maucherat

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from interface org.apache.catalina.Lifecycle

  `Lifecycle.SingleUse`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ADD_CHILD_EVENT`
  The ContainerEvent event type sent when a child container is added by `addChild()`.
  `static final String`
  `ADD_VALVE_EVENT`
  The ContainerEvent event type sent when a valve is added by `addValve()`, if this Container supports pipelines.
  `static final String`
  `REMOVE_CHILD_EVENT`
  The ContainerEvent event type sent when a child container is removed by `removeChild()`.
  `static final String`
  `REMOVE_VALVE_EVENT`
  The ContainerEvent event type sent when a valve is removed by `removeValve()`, if this Container supports pipelines.

  ### Fields inherited from interface org.apache.catalina.Lifecycle

  `AFTER_DESTROY_EVENT, AFTER_INIT_EVENT, AFTER_START_EVENT, AFTER_STOP_EVENT, BEFORE_DESTROY_EVENT, BEFORE_INIT_EVENT, BEFORE_START_EVENT, BEFORE_STOP_EVENT, CONFIGURE_START_EVENT, CONFIGURE_STOP_EVENT, PERIODIC_EVENT, START_EVENT, STOP_EVENT`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addChild(Container child)`
  Add a new child Container to those associated with this Container, if supported.
  `void`
  `addContainerListener(ContainerListener listener)`
  Add a container event listener to this component.
  `void`
  `addPropertyChangeListener(PropertyChangeListener listener)`
  Add a property change listener to this component.
  `void`
  `backgroundProcess()`
  Execute a periodic task, such as reloading, etc.
  `Container`
  `findChild(String name)`
  Obtain a child Container by name.
  `Container[]`
  `findChildren()`
  Obtain the child Containers associated with this Container.
  `ContainerListener[]`
  `findContainerListeners()`
  Obtain the container listeners associated with this Container.
  `void`
  `fireContainerEvent(String type, Object data)`
  Notify all container event listeners that a particular event has occurred for this Container.
  `AccessLog`
  `getAccessLog()`
  Obtain the AccessLog to use to log a request/response that is destined for this container.
  `int`
  `getBackgroundProcessorDelay()`
  Get the delay between the invocation of the backgroundProcess method on this container and its children.
  `File`
  `getCatalinaBase()`
  Obtain the location of CATALINA_BASE.
  `File`
  `getCatalinaHome()`
  Obtain the location of CATALINA_HOME.
  `Cluster`
  `getCluster()`
  Get the Cluster for this container.
  `static String`
  `getConfigPath(Container container, String resourceName)`
  Find the configuration path where a configuration resource is located.
  `String`
  `getDomain()`
  Obtain the JMX domain under which this container will be / has been registered.
  `Log`
  `getLogger()`
  Obtain the log to which events for this container should be logged.
  `String`
  `getLogName()`
  Return the logger name that the container will use.
  `String`
  `getMBeanKeyProperties()`
  Calculate the key properties string to be added to an object's `ObjectName` to indicate that it is associated with this container.
  `String`
  `getName()`
  Return a name string (suitable for use by humans) that describes this Container.
  `ObjectName`
  `getObjectName()`
  Obtain the JMX name for this container.
  `Container`
  `getParent()`
  Get the parent container.
  `ClassLoader`
  `getParentClassLoader()`
  Get the parent class loader.
  `Pipeline`
  `getPipeline()`
  Return the Pipeline object that manages the Valves associated with this Container.
  `Realm`
  `getRealm()`
  Obtain the Realm with which this Container is associated.
  `static Service`
  `getService(Container container)`
  Return the Service to which this container belongs.
  `int`
  `getStartStopThreads()`
  Obtain the number of threads available for starting and stopping any children associated with this container.
  `void`
  `logAccess(Request request, Response response, long time, boolean useDefault)`
  Log a request/response that was destined for this container but has been handled earlier in the processing chain so that the request/response still appears in the correct access logs.
  `void`
  `removeChild(Container child)`
  Remove an existing child Container from association with this parent Container.
  `void`
  `removeContainerListener(ContainerListener listener)`
  Remove a container event listener from this component.
  `void`
  `removePropertyChangeListener(PropertyChangeListener listener)`
  Remove a property change listener from this component.
  `void`
  `setBackgroundProcessorDelay(int delay)`
  Set the delay between the invocation of the execute method on this container and its children.
  `void`
  `setCluster(Cluster cluster)`
  Set the Cluster with which this Container is associated.
  `void`
  `setName(String name)`
  Set a name string (suitable for use by humans) that describes this Container.
  `void`
  `setParent(Container container)`
  Set the parent Container to which this Container is being added as a child.
  `void`
  `setParentClassLoader(ClassLoader parent)`
  Set the parent class loader for this component.
  `void`
  `setRealm(Realm realm)`
  Set the Realm with which this Container is associated.
  `void`
  `setStartStopThreads(int startStopThreads)`
  Sets the number of threads available for starting and stopping any children associated with this container.

  ### Methods inherited from interface org.apache.catalina.Lifecycle

  `addLifecycleListener, destroy, findLifecycleListeners, getState, getStateName, init, removeLifecycleListener, start, stop`

- ## Field Details

  - ### ADD_CHILD_EVENT

    static final String ADD_CHILD_EVENT
    The ContainerEvent event type sent when a child container is added by `addChild()`.
    See Also:
      - Constant Field Values

  - ### ADD_VALVE_EVENT

    static final String ADD_VALVE_EVENT
    The ContainerEvent event type sent when a valve is added by `addValve()`, if this Container supports pipelines.
    See Also:
      - Constant Field Values

  - ### REMOVE_CHILD_EVENT

    static final String REMOVE_CHILD_EVENT
    The ContainerEvent event type sent when a child container is removed by `removeChild()`.
    See Also:
      - Constant Field Values

  - ### REMOVE_VALVE_EVENT

    static final String REMOVE_VALVE_EVENT
    The ContainerEvent event type sent when a valve is removed by `removeValve()`, if this Container supports pipelines.
    See Also:
      - Constant Field Values

- ## Method Details

  - ### getLogger

    Log getLogger()
    Obtain the log to which events for this container should be logged.
    Returns:
      The Logger with which this Container is associated. If there is no associated Logger, return the Logger associated with the parent Container (if any); otherwise return `null`.

  - ### getLogName

    String getLogName()
    Return the logger name that the container will use.
    Returns:
      the abbreviated name of this container for logging messages

  - ### getObjectName

    ObjectName getObjectName()
    Obtain the JMX name for this container.
    Returns:
      the JMX name associated with this container.

  - ### getDomain

    String getDomain()
    Obtain the JMX domain under which this container will be / has been registered.
    Returns:
      The JMX domain name

  - ### getMBeanKeyProperties

    String getMBeanKeyProperties()
    Calculate the key properties string to be added to an object's `ObjectName` to indicate that it is associated with this container.
    Returns:
      A string suitable for appending to the ObjectName

  - ### getPipeline

    Pipeline getPipeline()
    Return the Pipeline object that manages the Valves associated with this Container.
    Returns:
      The Pipeline

  - ### getCluster

    Cluster getCluster()
    Get the Cluster for this container.
    Returns:
      The Cluster with which this Container is associated. If there is no associated Cluster, return the Cluster associated with our parent Container (if any); otherwise return `null`.

  - ### setCluster

    void setCluster(Cluster cluster)
    Set the Cluster with which this Container is associated.
    Parameters:
      `cluster` - the Cluster with which this Container is associated.

  - ### getBackgroundProcessorDelay

    int getBackgroundProcessorDelay()
    Get the delay between the invocation of the backgroundProcess method on this container and its children. Child containers will not be invoked if their delay value is positive (which would mean they are using their own thread). Setting this to a positive value will cause a thread to be spawned. After waiting the specified amount of time, the thread will invoke the `backgroundProcess()` method on this container and all children with non-positive delay values.
    Returns:
      The delay between the invocation of the backgroundProcess method on this container and its children. A non-positive value indicates that background processing will be managed by the parent.

  - ### setBackgroundProcessorDelay

    void setBackgroundProcessorDelay(int delay)
    Set the delay between the invocation of the execute method on this container and its children.
    Parameters:
      `delay` - The delay in seconds between the invocation of backgroundProcess methods

  - ### getName

    String getName()
    Return a name string (suitable for use by humans) that describes this Container. Within the set of child containers belonging to a particular parent, Container names must be unique.
    Returns:
      The human readable name of this container.

  - ### setName

    void setName(String name)
    Set a name string (suitable for use by humans) that describes this Container. Within the set of child containers belonging to a particular parent, Container names must be unique.
    Parameters:
      `name` - New name of this container
    Throws:
      `IllegalStateException` - if this Container has already been added to the children of a parent Container (after which the name may not be changed)

  - ### getParent

    Container getParent()
    Get the parent container.
    Returns:
      Return the Container for which this Container is a child, if there is one. If there is no defined parent, return `null`.

  - ### setParent

    void setParent(Container container)
    Set the parent Container to which this Container is being added as a child. This Container may refuse to become attached to the specified Container by throwing an exception.
    Parameters:
      `container` - Container to which this Container is being added as a child
    Throws:
      `IllegalArgumentException` - if this Container refuses to become attached to the specified Container

  - ### getParentClassLoader

    ClassLoader getParentClassLoader()
    Get the parent class loader.
    Returns:
      the parent class loader for this component. If not set, return `getParent()`.`getParentClassLoader()`. If no parent has been set, return the system class loader.

  - ### setParentClassLoader

    void setParentClassLoader(ClassLoader parent)
    Set the parent class loader for this component. For `Context`s this call is meaningful only before a Loader has been configured, and the specified value (if non-null) should be passed as an argument to the class loader constructor.
    Parameters:
      `parent` - The new parent class loader

  - ### getRealm

    Realm getRealm()
    Obtain the Realm with which this Container is associated.
    Returns:
      The associated Realm; if there is no associated Realm, the Realm associated with the parent Container (if any); otherwise return `null`.

  - ### setRealm

    void setRealm(Realm realm)
    Set the Realm with which this Container is associated.
    Parameters:
      `realm` - The newly associated Realm

  - ### getConfigPath

    static String getConfigPath(Container container, String resourceName)
    Find the configuration path where a configuration resource is located.
    Parameters:
      `container` - The container
      `resourceName` - The resource file name
    Returns:
      the configuration path

  - ### getService

    static Service getService(Container container)
    Return the Service to which this container belongs.
    Parameters:
      `container` - The container to start from
    Returns:
      the Service, or null if not found

  - ### backgroundProcess

    void backgroundProcess()
    Execute a periodic task, such as reloading, etc. This method will be invoked inside the classloading context of this container. Unexpected throwables will be caught and logged.

  - ### addChild

    void addChild(Container child)
    Add a new child Container to those associated with this Container, if supported. Prior to adding this Container to the set of children, the child's `setParent()` method must be called, with this Container as an argument. This method may thrown an `IllegalArgumentException` if this Container chooses not to be attached to the specified Container, in which case it is not added
    Parameters:
      `child` - New child Container to be added
    Throws:
      `IllegalArgumentException` - if this exception is thrown by the `setParent()` method of the child Container
      `IllegalArgumentException` - if the new child does not have a name unique from that of existing children of this Container
      `IllegalStateException` - if this Container does not support child Containers

  - ### addContainerListener

    void addContainerListener(ContainerListener listener)
    Add a container event listener to this component.
    Parameters:
      `listener` - The listener to add

  - ### addPropertyChangeListener

    void addPropertyChangeListener(PropertyChangeListener listener)
    Add a property change listener to this component.
    Parameters:
      `listener` - The listener to add

  - ### findChild

    Container findChild(String name)
    Obtain a child Container by name.
    Parameters:
      `name` - Name of the child Container to be retrieved
    Returns:
      The child Container with the given name or `null` if no such child exists.

  - ### findChildren

    Container[] findChildren()
    Obtain the child Containers associated with this Container.
    Returns:
      An array containing all children of this container. If this Container has no children, a zero-length array is returned.

  - ### findContainerListeners

    ContainerListener[] findContainerListeners()
    Obtain the container listeners associated with this Container.
    Returns:
      An array containing the container listeners associated with this Container. If this Container has no registered container listeners, a zero-length array is returned.

  - ### removeChild

    void removeChild(Container child)
    Remove an existing child Container from association with this parent Container.
    Parameters:
      `child` - Existing child Container to be removed

  - ### removeContainerListener

    void removeContainerListener(ContainerListener listener)
    Remove a container event listener from this component.
    Parameters:
      `listener` - The listener to remove

  - ### removePropertyChangeListener

    void removePropertyChangeListener(PropertyChangeListener listener)
    Remove a property change listener from this component.
    Parameters:
      `listener` - The listener to remove

  - ### fireContainerEvent

    void fireContainerEvent(String type, Object data)
    Notify all container event listeners that a particular event has occurred for this Container. The default implementation performs this notification synchronously using the calling thread.
    Parameters:
      `type` - Event type
      `data` - Event data

  - ### logAccess

    void logAccess(Request request, Response response, long time, boolean useDefault)
    Log a request/response that was destined for this container but has been handled earlier in the processing chain so that the request/response still appears in the correct access logs.
    Parameters:
      `request` - Request (associated with the response) to log
      `response` - Response (associated with the request) to log
      `time` - Time taken to process the request/response in milliseconds (use 0 if not known)
      `useDefault` - Flag that indicates that the request/response should be logged in the engine's default access log

  - ### getAccessLog

    AccessLog getAccessLog()
    Obtain the AccessLog to use to log a request/response that is destined for this container. This is typically used when the request/response was handled (and rejected) earlier in the processing chain so that the request/response still appears in the correct access logs.
    Returns:
      The AccessLog to use for a request/response destined for this container

  - ### getStartStopThreads

    int getStartStopThreads()
    Obtain the number of threads available for starting and stopping any children associated with this container. This allows start/stop calls to children to be processed in parallel.
    Returns:
      The currently configured number of threads used to start/stop children associated with this container

  - ### setStartStopThreads

    void setStartStopThreads(int startStopThreads)
    Sets the number of threads available for starting and stopping any children associated with this container. This allows start/stop calls to children to be processed in parallel.
    Parameters:
      `startStopThreads` - The new number of threads to be used

  - ### getCatalinaBase

    File getCatalinaBase()
    Obtain the location of CATALINA_BASE.
    Returns:
      The location of CATALINA_BASE.

  - ### getCatalinaHome

    File getCatalinaHome()
    Obtain the location of CATALINA_HOME.
    Returns:
      The location of CATALINA_HOME.